t / test-lib.shon commit t: add means to disable '-x' tracing for individual test scripts (5fc98e7)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39# If we were built with ASAN, it may complain about leaks
  40# of program-lifetime variables. Disable it by default to lower
  41# the noise level. This needs to happen at the start of the script,
  42# before we even do our "did we build git yet" check (since we don't
  43# want that one to complain to stderr).
  44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
  45export ASAN_OPTIONS
  46
  47# If LSAN is in effect we _do_ want leak checking, but we still
  48# want to abort so that we notice the problems.
  49: ${LSAN_OPTIONS=abort_on_error=1}
  50export LSAN_OPTIONS
  51
  52################################################################
  53# It appears that people try to run tests without building...
  54"$GIT_BUILD_DIR/git" >/dev/null
  55if test $? != 1
  56then
  57        echo >&2 'error: you do not seem to have built git yet.'
  58        exit 1
  59fi
  60
  61. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  62export PERL_PATH SHELL_PATH
  63
  64# if --tee was passed, write the output not only to the terminal, but
  65# additionally to the file test-results/$BASENAME.out, too.
  66case "$GIT_TEST_TEE_STARTED, $* " in
  67done,*)
  68        # do not redirect again
  69        ;;
  70*' --tee '*|*' --va'*|*' --verbose-log '*)
  71        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  72        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  73
  74        # Make this filename available to the sub-process in case it is using
  75        # --verbose-log.
  76        GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
  77        export GIT_TEST_TEE_OUTPUT_FILE
  78
  79        # Truncate before calling "tee -a" to get rid of the results
  80        # from any previous runs.
  81        >"$GIT_TEST_TEE_OUTPUT_FILE"
  82
  83        (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
  84         echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
  85        test "$(cat "$BASE.exit")" = 0
  86        exit
  87        ;;
  88esac
  89
  90# For repeatability, reset the environment to known value.
  91# TERM is sanitized below, after saving color control sequences.
  92LANG=C
  93LC_ALL=C
  94PAGER=cat
  95TZ=UTC
  96export LANG LC_ALL PAGER TZ
  97EDITOR=:
  98# A call to "unset" with no arguments causes at least Solaris 10
  99# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
 100# deriving from the command substitution clustered with the other
 101# ones.
 102unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
 103        my @env = keys %ENV;
 104        my $ok = join("|", qw(
 105                TRACE
 106                DEBUG
 107                TEST
 108                .*_TEST
 109                PROVE
 110                VALGRIND
 111                UNZIP
 112                PERF_
 113                CURL_VERBOSE
 114                TRACE_CURL
 115        ));
 116        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 117        print join("\n", @vars);
 118')
 119unset XDG_CONFIG_HOME
 120unset GITPERLLIB
 121GIT_AUTHOR_EMAIL=author@example.com
 122GIT_AUTHOR_NAME='A U Thor'
 123GIT_COMMITTER_EMAIL=committer@example.com
 124GIT_COMMITTER_NAME='C O Mitter'
 125GIT_MERGE_VERBOSITY=5
 126GIT_MERGE_AUTOEDIT=no
 127export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 128export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 129export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 130export EDITOR
 131
 132# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 133GIT_TRACE_BARE=1
 134export GIT_TRACE_BARE
 135
 136if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 137then
 138        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 139        export GIT_INDEX_VERSION
 140fi
 141
 142# Add libc MALLOC and MALLOC_PERTURB test
 143# only if we are not executing the test with valgrind
 144if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 145   test -n "$TEST_NO_MALLOC_CHECK"
 146then
 147        setup_malloc_check () {
 148                : nothing
 149        }
 150        teardown_malloc_check () {
 151                : nothing
 152        }
 153else
 154        setup_malloc_check () {
 155                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 156                export MALLOC_CHECK_ MALLOC_PERTURB_
 157        }
 158        teardown_malloc_check () {
 159                unset MALLOC_CHECK_ MALLOC_PERTURB_
 160        }
 161fi
 162
 163# Protect ourselves from common misconfiguration to export
 164# CDPATH into the environment
 165unset CDPATH
 166
 167unset GREP_OPTIONS
 168unset UNZIP
 169
 170case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1711|2|true)
 172        GIT_TRACE=4
 173        ;;
 174esac
 175
 176# Convenience
 177#
 178# A regexp to match 5, 35 and 40 hexdigits
 179_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 180_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 181_x40="$_x35$_x05"
 182
 183# Zero SHA-1
 184_z40=0000000000000000000000000000000000000000
 185
 186EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 187EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 188
 189# Line feed
 190LF='
 191'
 192
 193# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 194# when case-folding filenames
 195u200c=$(printf '\342\200\214')
 196
 197export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
 198
 199# Each test should start with something like this, after copyright notices:
 200#
 201# test_description='Description of this test...
 202# This test checks if command xyzzy does the right thing...
 203# '
 204# . ./test-lib.sh
 205test "x$TERM" != "xdumb" && (
 206                test -t 1 &&
 207                tput bold >/dev/null 2>&1 &&
 208                tput setaf 1 >/dev/null 2>&1 &&
 209                tput sgr0 >/dev/null 2>&1
 210        ) &&
 211        color=t
 212
 213while test "$#" -ne 0
 214do
 215        case "$1" in
 216        -d|--d|--de|--deb|--debu|--debug)
 217                debug=t; shift ;;
 218        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 219                immediate=t; shift ;;
 220        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 221                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 222        -r)
 223                shift; test "$#" -ne 0 || {
 224                        echo 'error: -r requires an argument' >&2;
 225                        exit 1;
 226                }
 227                run_list=$1; shift ;;
 228        --run=*)
 229                run_list=${1#--*=}; shift ;;
 230        -h|--h|--he|--hel|--help)
 231                help=t; shift ;;
 232        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 233                verbose=t; shift ;;
 234        --verbose-only=*)
 235                verbose_only=${1#--*=}
 236                shift ;;
 237        -q|--q|--qu|--qui|--quie|--quiet)
 238                # Ignore --quiet under a TAP::Harness. Saying how many tests
 239                # passed without the ok/not ok details is always an error.
 240                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 241        --with-dashes)
 242                with_dashes=t; shift ;;
 243        --no-color)
 244                color=; shift ;;
 245        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 246                valgrind=memcheck
 247                shift ;;
 248        --valgrind=*)
 249                valgrind=${1#--*=}
 250                shift ;;
 251        --valgrind-only=*)
 252                valgrind_only=${1#--*=}
 253                shift ;;
 254        --tee)
 255                shift ;; # was handled already
 256        --root=*)
 257                root=${1#--*=}
 258                shift ;;
 259        --chain-lint)
 260                GIT_TEST_CHAIN_LINT=1
 261                shift ;;
 262        --no-chain-lint)
 263                GIT_TEST_CHAIN_LINT=0
 264                shift ;;
 265        -x)
 266                # Some test scripts can't be reliably traced  with '-x',
 267                # unless the test is run with a Bash version supporting
 268                # BASH_XTRACEFD (introduced in Bash v4.1).  Check whether
 269                # this test is marked as such, and ignore '-x' if it
 270                # isn't executed with a suitable Bash version.
 271                if test -z "$test_untraceable" || {
 272                     test -n "$BASH_VERSION" && {
 273                       test ${BASH_VERSINFO[0]} -gt 4 || {
 274                         test ${BASH_VERSINFO[0]} -eq 4 &&
 275                         test ${BASH_VERSINFO[1]} -ge 1
 276                       }
 277                     }
 278                   }
 279                then
 280                        trace=t
 281                else
 282                        echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
 283                fi
 284                shift ;;
 285        --verbose-log)
 286                verbose_log=t
 287                shift ;;
 288        *)
 289                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 290        esac
 291done
 292
 293if test -n "$valgrind_only"
 294then
 295        test -z "$valgrind" && valgrind=memcheck
 296        test -z "$verbose" && verbose_only="$valgrind_only"
 297elif test -n "$valgrind"
 298then
 299        test -z "$verbose_log" && verbose=t
 300fi
 301
 302if test -n "$trace" && test -z "$verbose_log"
 303then
 304        verbose=t
 305fi
 306
 307if test -n "$color"
 308then
 309        # Save the color control sequences now rather than run tput
 310        # each time say_color() is called.  This is done for two
 311        # reasons:
 312        #   * TERM will be changed to dumb
 313        #   * HOME will be changed to a temporary directory and tput
 314        #     might need to read ~/.terminfo from the original HOME
 315        #     directory to get the control sequences
 316        # Note:  This approach assumes the control sequences don't end
 317        # in a newline for any terminal of interest (command
 318        # substitutions strip trailing newlines).  Given that most
 319        # (all?) terminals in common use are related to ECMA-48, this
 320        # shouldn't be a problem.
 321        say_color_error=$(tput bold; tput setaf 1) # bold red
 322        say_color_skip=$(tput setaf 4) # blue
 323        say_color_warn=$(tput setaf 3) # brown/yellow
 324        say_color_pass=$(tput setaf 2) # green
 325        say_color_info=$(tput setaf 6) # cyan
 326        say_color_reset=$(tput sgr0)
 327        say_color_="" # no formatting for normal text
 328        say_color () {
 329                test -z "$1" && test -n "$quiet" && return
 330                eval "say_color_color=\$say_color_$1"
 331                shift
 332                printf "%s\\n" "$say_color_color$*$say_color_reset"
 333        }
 334else
 335        say_color() {
 336                test -z "$1" && test -n "$quiet" && return
 337                shift
 338                printf "%s\n" "$*"
 339        }
 340fi
 341
 342TERM=dumb
 343export TERM
 344
 345error () {
 346        say_color error "error: $*"
 347        GIT_EXIT_OK=t
 348        exit 1
 349}
 350
 351say () {
 352        say_color info "$*"
 353}
 354
 355if test -n "$HARNESS_ACTIVE"
 356then
 357        if test "$verbose" = t || test -n "$verbose_only"
 358        then
 359                printf 'Bail out! %s\n' \
 360                 'verbose mode forbidden under TAP harness; try --verbose-log'
 361                exit 1
 362        fi
 363fi
 364
 365test "${test_description}" != "" ||
 366error "Test script did not set test_description."
 367
 368if test "$help" = "t"
 369then
 370        printf '%s\n' "$test_description"
 371        exit 0
 372fi
 373
 374exec 5>&1
 375exec 6<&0
 376exec 7>&2
 377if test "$verbose_log" = "t"
 378then
 379        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 380elif test "$verbose" = "t"
 381then
 382        exec 4>&2 3>&1
 383else
 384        exec 4>/dev/null 3>/dev/null
 385fi
 386
 387# Send any "-x" output directly to stderr to avoid polluting tests
 388# which capture stderr. We can do this unconditionally since it
 389# has no effect if tracing isn't turned on.
 390#
 391# Note that this sets up the trace fd as soon as we assign the variable, so it
 392# must come after the creation of descriptor 4 above. Likewise, we must never
 393# unset this, as it has the side effect of closing descriptor 4, which we
 394# use to show verbose tests to the user.
 395#
 396# Note also that we don't need or want to export it. The tracing is local to
 397# this shell, and we would not want to influence any shells we exec.
 398BASH_XTRACEFD=4
 399
 400test_failure=0
 401test_count=0
 402test_fixed=0
 403test_broken=0
 404test_success=0
 405
 406test_external_has_tap=0
 407
 408die () {
 409        code=$?
 410        if test -n "$GIT_EXIT_OK"
 411        then
 412                exit $code
 413        else
 414                echo >&5 "FATAL: Unexpected exit with code $code"
 415                exit 1
 416        fi
 417}
 418
 419GIT_EXIT_OK=
 420trap 'die' EXIT
 421trap 'exit $?' INT
 422
 423# The user-facing functions are loaded from a separate file so that
 424# test_perf subshells can have them too
 425. "$TEST_DIRECTORY/test-lib-functions.sh"
 426
 427# You are not expected to call test_ok_ and test_failure_ directly, use
 428# the test_expect_* functions instead.
 429
 430test_ok_ () {
 431        test_success=$(($test_success + 1))
 432        say_color "" "ok $test_count - $@"
 433}
 434
 435test_failure_ () {
 436        test_failure=$(($test_failure + 1))
 437        say_color error "not ok $test_count - $1"
 438        shift
 439        printf '%s\n' "$*" | sed -e 's/^/#      /'
 440        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 441}
 442
 443test_known_broken_ok_ () {
 444        test_fixed=$(($test_fixed+1))
 445        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 446}
 447
 448test_known_broken_failure_ () {
 449        test_broken=$(($test_broken+1))
 450        say_color warn "not ok $test_count - $@ # TODO known breakage"
 451}
 452
 453test_debug () {
 454        test "$debug" = "" || eval "$1"
 455}
 456
 457match_pattern_list () {
 458        arg="$1"
 459        shift
 460        test -z "$*" && return 1
 461        for pattern_
 462        do
 463                case "$arg" in
 464                $pattern_)
 465                        return 0
 466                esac
 467        done
 468        return 1
 469}
 470
 471match_test_selector_list () {
 472        title="$1"
 473        shift
 474        arg="$1"
 475        shift
 476        test -z "$1" && return 0
 477
 478        # Both commas and whitespace are accepted as separators.
 479        OLDIFS=$IFS
 480        IFS='   ,'
 481        set -- $1
 482        IFS=$OLDIFS
 483
 484        # If the first selector is negative we include by default.
 485        include=
 486        case "$1" in
 487                !*) include=t ;;
 488        esac
 489
 490        for selector
 491        do
 492                orig_selector=$selector
 493
 494                positive=t
 495                case "$selector" in
 496                        !*)
 497                                positive=
 498                                selector=${selector##?}
 499                                ;;
 500                esac
 501
 502                test -z "$selector" && continue
 503
 504                case "$selector" in
 505                        *-*)
 506                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 507                                then
 508                                        echo "error: $title: invalid non-numeric in range" \
 509                                                "start: '$orig_selector'" >&2
 510                                        exit 1
 511                                fi
 512                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 513                                then
 514                                        echo "error: $title: invalid non-numeric in range" \
 515                                                "end: '$orig_selector'" >&2
 516                                        exit 1
 517                                fi
 518                                ;;
 519                        *)
 520                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 521                                then
 522                                        echo "error: $title: invalid non-numeric in test" \
 523                                                "selector: '$orig_selector'" >&2
 524                                        exit 1
 525                                fi
 526                esac
 527
 528                # Short cut for "obvious" cases
 529                test -z "$include" && test -z "$positive" && continue
 530                test -n "$include" && test -n "$positive" && continue
 531
 532                case "$selector" in
 533                        -*)
 534                                if test $arg -le ${selector#-}
 535                                then
 536                                        include=$positive
 537                                fi
 538                                ;;
 539                        *-)
 540                                if test $arg -ge ${selector%-}
 541                                then
 542                                        include=$positive
 543                                fi
 544                                ;;
 545                        *-*)
 546                                if test ${selector%%-*} -le $arg \
 547                                        && test $arg -le ${selector#*-}
 548                                then
 549                                        include=$positive
 550                                fi
 551                                ;;
 552                        *)
 553                                if test $arg -eq $selector
 554                                then
 555                                        include=$positive
 556                                fi
 557                                ;;
 558                esac
 559        done
 560
 561        test -n "$include"
 562}
 563
 564maybe_teardown_verbose () {
 565        test -z "$verbose_only" && return
 566        exec 4>/dev/null 3>/dev/null
 567        verbose=
 568}
 569
 570last_verbose=t
 571maybe_setup_verbose () {
 572        test -z "$verbose_only" && return
 573        if match_pattern_list $test_count $verbose_only
 574        then
 575                exec 4>&2 3>&1
 576                # Emit a delimiting blank line when going from
 577                # non-verbose to verbose.  Within verbose mode the
 578                # delimiter is printed by test_expect_*.  The choice
 579                # of the initial $last_verbose is such that before
 580                # test 1, we do not print it.
 581                test -z "$last_verbose" && echo >&3 ""
 582                verbose=t
 583        else
 584                exec 4>/dev/null 3>/dev/null
 585                verbose=
 586        fi
 587        last_verbose=$verbose
 588}
 589
 590maybe_teardown_valgrind () {
 591        test -z "$GIT_VALGRIND" && return
 592        GIT_VALGRIND_ENABLED=
 593}
 594
 595maybe_setup_valgrind () {
 596        test -z "$GIT_VALGRIND" && return
 597        if test -z "$valgrind_only"
 598        then
 599                GIT_VALGRIND_ENABLED=t
 600                return
 601        fi
 602        GIT_VALGRIND_ENABLED=
 603        if match_pattern_list $test_count $valgrind_only
 604        then
 605                GIT_VALGRIND_ENABLED=t
 606        fi
 607}
 608
 609want_trace () {
 610        test "$trace" = t && {
 611                test "$verbose" = t || test "$verbose_log" = t
 612        }
 613}
 614
 615# This is a separate function because some tests use
 616# "return" to end a test_expect_success block early
 617# (and we want to make sure we run any cleanup like
 618# "set +x").
 619test_eval_inner_ () {
 620        # Do not add anything extra (including LF) after '$*'
 621        eval "
 622                want_trace && set -x
 623                $*"
 624}
 625
 626test_eval_ () {
 627        # If "-x" tracing is in effect, then we want to avoid polluting stderr
 628        # with non-test commands. But once in "set -x" mode, we cannot prevent
 629        # the shell from printing the "set +x" to turn it off (nor the saving
 630        # of $? before that). But we can make sure that the output goes to
 631        # /dev/null.
 632        #
 633        # There are a few subtleties here:
 634        #
 635        #   - we have to redirect descriptor 4 in addition to 2, to cover
 636        #     BASH_XTRACEFD
 637        #
 638        #   - the actual eval has to come before the redirection block (since
 639        #     it needs to see descriptor 4 to set up its stderr)
 640        #
 641        #   - likewise, any error message we print must be outside the block to
 642        #     access descriptor 4
 643        #
 644        #   - checking $? has to come immediately after the eval, but it must
 645        #     be _inside_ the block to avoid polluting the "set -x" output
 646        #
 647
 648        test_eval_inner_ "$@" </dev/null >&3 2>&4
 649        {
 650                test_eval_ret_=$?
 651                if want_trace
 652                then
 653                        set +x
 654                fi
 655        } 2>/dev/null 4>&2
 656
 657        if test "$test_eval_ret_" != 0 && want_trace
 658        then
 659                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 660        fi
 661        return $test_eval_ret_
 662}
 663
 664test_run_ () {
 665        test_cleanup=:
 666        expecting_failure=$2
 667
 668        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 669                # turn off tracing for this test-eval, as it simply creates
 670                # confusing noise in the "-x" output
 671                trace_tmp=$trace
 672                trace=
 673                # 117 is magic because it is unlikely to match the exit
 674                # code of other programs
 675                if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
 676                then
 677                        error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
 678                fi
 679                trace=$trace_tmp
 680        fi
 681
 682        setup_malloc_check
 683        test_eval_ "$1"
 684        eval_ret=$?
 685        teardown_malloc_check
 686
 687        if test -z "$immediate" || test $eval_ret = 0 ||
 688           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 689        then
 690                setup_malloc_check
 691                test_eval_ "$test_cleanup"
 692                teardown_malloc_check
 693        fi
 694        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 695        then
 696                echo ""
 697        fi
 698        return "$eval_ret"
 699}
 700
 701test_start_ () {
 702        test_count=$(($test_count+1))
 703        maybe_setup_verbose
 704        maybe_setup_valgrind
 705}
 706
 707test_finish_ () {
 708        echo >&3 ""
 709        maybe_teardown_valgrind
 710        maybe_teardown_verbose
 711}
 712
 713test_skip () {
 714        to_skip=
 715        skipped_reason=
 716        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 717        then
 718                to_skip=t
 719                skipped_reason="GIT_SKIP_TESTS"
 720        fi
 721        if test -z "$to_skip" && test -n "$test_prereq" &&
 722           ! test_have_prereq "$test_prereq"
 723        then
 724                to_skip=t
 725
 726                of_prereq=
 727                if test "$missing_prereq" != "$test_prereq"
 728                then
 729                        of_prereq=" of $test_prereq"
 730                fi
 731                skipped_reason="missing $missing_prereq${of_prereq}"
 732        fi
 733        if test -z "$to_skip" && test -n "$run_list" &&
 734                ! match_test_selector_list '--run' $test_count "$run_list"
 735        then
 736                to_skip=t
 737                skipped_reason="--run"
 738        fi
 739
 740        case "$to_skip" in
 741        t)
 742                say_color skip >&3 "skipping test: $@"
 743                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 744                : true
 745                ;;
 746        *)
 747                false
 748                ;;
 749        esac
 750}
 751
 752# stub; perf-lib overrides it
 753test_at_end_hook_ () {
 754        :
 755}
 756
 757test_done () {
 758        GIT_EXIT_OK=t
 759
 760        if test -z "$HARNESS_ACTIVE"
 761        then
 762                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 763                mkdir -p "$test_results_dir"
 764                base=${0##*/}
 765                test_results_path="$test_results_dir/${base%.sh}.counts"
 766
 767                cat >"$test_results_path" <<-EOF
 768                total $test_count
 769                success $test_success
 770                fixed $test_fixed
 771                broken $test_broken
 772                failed $test_failure
 773
 774                EOF
 775        fi
 776
 777        if test "$test_fixed" != 0
 778        then
 779                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 780        fi
 781        if test "$test_broken" != 0
 782        then
 783                say_color warn "# still have $test_broken known breakage(s)"
 784        fi
 785        if test "$test_broken" != 0 || test "$test_fixed" != 0
 786        then
 787                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 788                msg="remaining $test_remaining test(s)"
 789        else
 790                test_remaining=$test_count
 791                msg="$test_count test(s)"
 792        fi
 793        case "$test_failure" in
 794        0)
 795                if test $test_external_has_tap -eq 0
 796                then
 797                        if test $test_remaining -gt 0
 798                        then
 799                                say_color pass "# passed all $msg"
 800                        fi
 801
 802                        # Maybe print SKIP message
 803                        test -z "$skip_all" || skip_all="# SKIP $skip_all"
 804                        case "$test_count" in
 805                        0)
 806                                say "1..$test_count${skip_all:+ $skip_all}"
 807                                ;;
 808                        *)
 809                                test -z "$skip_all" ||
 810                                say_color warn "$skip_all"
 811                                say "1..$test_count"
 812                                ;;
 813                        esac
 814                fi
 815
 816                if test -z "$debug"
 817                then
 818                        test -d "$TRASH_DIRECTORY" ||
 819                        error "Tests passed but trash directory already removed before test cleanup; aborting"
 820
 821                        cd "$TRASH_DIRECTORY/.." &&
 822                        rm -fr "$TRASH_DIRECTORY" ||
 823                        error "Tests passed but test cleanup failed; aborting"
 824                fi
 825                test_at_end_hook_
 826
 827                exit 0 ;;
 828
 829        *)
 830                if test $test_external_has_tap -eq 0
 831                then
 832                        say_color error "# failed $test_failure among $msg"
 833                        say "1..$test_count"
 834                fi
 835
 836                exit 1 ;;
 837
 838        esac
 839}
 840
 841if test -n "$valgrind"
 842then
 843        make_symlink () {
 844                test -h "$2" &&
 845                test "$1" = "$(readlink "$2")" || {
 846                        # be super paranoid
 847                        if mkdir "$2".lock
 848                        then
 849                                rm -f "$2" &&
 850                                ln -s "$1" "$2" &&
 851                                rm -r "$2".lock
 852                        else
 853                                while test -d "$2".lock
 854                                do
 855                                        say "Waiting for lock on $2."
 856                                        sleep 1
 857                                done
 858                        fi
 859                }
 860        }
 861
 862        make_valgrind_symlink () {
 863                # handle only executables, unless they are shell libraries that
 864                # need to be in the exec-path.
 865                test -x "$1" ||
 866                test "# " = "$(head -c 2 <"$1")" ||
 867                return;
 868
 869                base=$(basename "$1")
 870                case "$base" in
 871                test-*)
 872                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
 873                        ;;
 874                *)
 875                        symlink_target="$GIT_BUILD_DIR/$base"
 876                        ;;
 877                esac
 878                # do not override scripts
 879                if test -x "$symlink_target" &&
 880                    test ! -d "$symlink_target" &&
 881                    test "#!" != "$(head -c 2 < "$symlink_target")"
 882                then
 883                        symlink_target=../valgrind.sh
 884                fi
 885                case "$base" in
 886                *.sh|*.perl)
 887                        symlink_target=../unprocessed-script
 888                esac
 889                # create the link, or replace it if it is out of date
 890                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 891        }
 892
 893        # override all git executables in TEST_DIRECTORY/..
 894        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 895        mkdir -p "$GIT_VALGRIND"/bin
 896        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
 897        do
 898                make_valgrind_symlink $file
 899        done
 900        # special-case the mergetools loadables
 901        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 902        OLDIFS=$IFS
 903        IFS=:
 904        for path in $PATH
 905        do
 906                ls "$path"/git-* 2> /dev/null |
 907                while read file
 908                do
 909                        make_valgrind_symlink "$file"
 910                done
 911        done
 912        IFS=$OLDIFS
 913        PATH=$GIT_VALGRIND/bin:$PATH
 914        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 915        export GIT_VALGRIND
 916        GIT_VALGRIND_MODE="$valgrind"
 917        export GIT_VALGRIND_MODE
 918        GIT_VALGRIND_ENABLED=t
 919        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 920        export GIT_VALGRIND_ENABLED
 921elif test -n "$GIT_TEST_INSTALLED"
 922then
 923        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 924        error "Cannot run git from $GIT_TEST_INSTALLED."
 925        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 926        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 927else # normal case, use ../bin-wrappers only unless $with_dashes:
 928        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 929        if ! test -x "$git_bin_dir/git"
 930        then
 931                if test -z "$with_dashes"
 932                then
 933                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 934                fi
 935                with_dashes=t
 936        fi
 937        PATH="$git_bin_dir:$PATH"
 938        GIT_EXEC_PATH=$GIT_BUILD_DIR
 939        if test -n "$with_dashes"
 940        then
 941                PATH="$GIT_BUILD_DIR:$PATH"
 942        fi
 943fi
 944GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 945GIT_CONFIG_NOSYSTEM=1
 946GIT_ATTR_NOSYSTEM=1
 947export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 948
 949if test -z "$GIT_TEST_CMP"
 950then
 951        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 952        then
 953                GIT_TEST_CMP="$DIFF -c"
 954        else
 955                GIT_TEST_CMP="$DIFF -u"
 956        fi
 957fi
 958
 959GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
 960export GITPERLLIB
 961test -d "$GIT_BUILD_DIR"/templates/blt || {
 962        error "You haven't built things yet, have you?"
 963}
 964
 965if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
 966then
 967        echo >&2 'You need to build test-chmtime:'
 968        echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
 969        exit 1
 970fi
 971
 972# Test repository
 973TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 974test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 975case "$TRASH_DIRECTORY" in
 976/*) ;; # absolute path is good
 977 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 978esac
 979rm -fr "$TRASH_DIRECTORY" || {
 980        GIT_EXIT_OK=t
 981        echo >&5 "FATAL: Cannot prepare test area"
 982        exit 1
 983}
 984
 985HOME="$TRASH_DIRECTORY"
 986GNUPGHOME="$HOME/gnupg-home-not-used"
 987export HOME GNUPGHOME
 988
 989if test -z "$TEST_NO_CREATE_REPO"
 990then
 991        test_create_repo "$TRASH_DIRECTORY"
 992else
 993        mkdir -p "$TRASH_DIRECTORY"
 994fi
 995# Use -P to resolve symlinks in our working directory so that the cwd
 996# in subprocesses like git equals our $PWD (for pathname comparisons).
 997cd -P "$TRASH_DIRECTORY" || exit 1
 998
 999this_test=${0##*/}
1000this_test=${this_test%%-*}
1001if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1002then
1003        say_color info >&3 "skipping test $this_test altogether"
1004        skip_all="skip all tests in $this_test"
1005        test_done
1006fi
1007
1008# Provide an implementation of the 'yes' utility
1009yes () {
1010        if test $# = 0
1011        then
1012                y=y
1013        else
1014                y="$*"
1015        fi
1016
1017        i=0
1018        while test $i -lt 99
1019        do
1020                echo "$y"
1021                i=$(($i+1))
1022        done
1023}
1024
1025# Fix some commands on Windows
1026uname_s=$(uname -s)
1027case $uname_s in
1028*MINGW*)
1029        # Windows has its own (incompatible) sort and find
1030        sort () {
1031                /usr/bin/sort "$@"
1032        }
1033        find () {
1034                /usr/bin/find "$@"
1035        }
1036        # git sees Windows-style pwd
1037        pwd () {
1038                builtin pwd -W
1039        }
1040        # no POSIX permissions
1041        # backslashes in pathspec are converted to '/'
1042        # exec does not inherit the PID
1043        test_set_prereq MINGW
1044        test_set_prereq NATIVE_CRLF
1045        test_set_prereq SED_STRIPS_CR
1046        test_set_prereq GREP_STRIPS_CR
1047        GIT_TEST_CMP=mingw_test_cmp
1048        ;;
1049*CYGWIN*)
1050        test_set_prereq POSIXPERM
1051        test_set_prereq EXECKEEPSPID
1052        test_set_prereq CYGWIN
1053        test_set_prereq SED_STRIPS_CR
1054        test_set_prereq GREP_STRIPS_CR
1055        ;;
1056*)
1057        test_set_prereq POSIXPERM
1058        test_set_prereq BSLASHPSPEC
1059        test_set_prereq EXECKEEPSPID
1060        ;;
1061esac
1062
1063( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1064test -z "$NO_PERL" && test_set_prereq PERL
1065test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1066test -z "$NO_PYTHON" && test_set_prereq PYTHON
1067test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1068test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1069test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1070test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1071
1072# Can we rely on git's output in the C locale?
1073if test -n "$GETTEXT_POISON"
1074then
1075        GIT_GETTEXT_POISON=YesPlease
1076        export GIT_GETTEXT_POISON
1077        test_set_prereq GETTEXT_POISON
1078else
1079        test_set_prereq C_LOCALE_OUTPUT
1080fi
1081
1082test_lazy_prereq PIPE '
1083        # test whether the filesystem supports FIFOs
1084        test_have_prereq !MINGW,!CYGWIN &&
1085        rm -f testfifo && mkfifo testfifo
1086'
1087
1088test_lazy_prereq SYMLINKS '
1089        # test whether the filesystem supports symbolic links
1090        ln -s x y && test -h y
1091'
1092
1093test_lazy_prereq FILEMODE '
1094        test "$(git config --bool core.filemode)" = true
1095'
1096
1097test_lazy_prereq CASE_INSENSITIVE_FS '
1098        echo good >CamelCase &&
1099        echo bad >camelcase &&
1100        test "$(cat CamelCase)" != good
1101'
1102
1103test_lazy_prereq UTF8_NFD_TO_NFC '
1104        # check whether FS converts nfd unicode to nfc
1105        auml=$(printf "\303\244")
1106        aumlcdiar=$(printf "\141\314\210")
1107        >"$auml" &&
1108        case "$(echo *)" in
1109        "$aumlcdiar")
1110                true ;;
1111        *)
1112                false ;;
1113        esac
1114'
1115
1116test_lazy_prereq AUTOIDENT '
1117        sane_unset GIT_AUTHOR_NAME &&
1118        sane_unset GIT_AUTHOR_EMAIL &&
1119        git var GIT_AUTHOR_IDENT
1120'
1121
1122test_lazy_prereq EXPENSIVE '
1123        test -n "$GIT_TEST_LONG"
1124'
1125
1126test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1127        test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1128'
1129
1130test_lazy_prereq USR_BIN_TIME '
1131        test -x /usr/bin/time
1132'
1133
1134test_lazy_prereq NOT_ROOT '
1135        uid=$(id -u) &&
1136        test "$uid" != 0
1137'
1138
1139test_lazy_prereq JGIT '
1140        type jgit
1141'
1142
1143# SANITY is about "can you correctly predict what the filesystem would
1144# do by only looking at the permission bits of the files and
1145# directories?"  A typical example of !SANITY is running the test
1146# suite as root, where a test may expect "chmod -r file && cat file"
1147# to fail because file is supposed to be unreadable after a successful
1148# chmod.  In an environment (i.e. combination of what filesystem is
1149# being used and who is running the tests) that lacks SANITY, you may
1150# be able to delete or create a file when the containing directory
1151# doesn't have write permissions, or access a file even if the
1152# containing directory doesn't have read or execute permissions.
1153
1154test_lazy_prereq SANITY '
1155        mkdir SANETESTD.1 SANETESTD.2 &&
1156
1157        chmod +w SANETESTD.1 SANETESTD.2 &&
1158        >SANETESTD.1/x 2>SANETESTD.2/x &&
1159        chmod -w SANETESTD.1 &&
1160        chmod -r SANETESTD.1/x &&
1161        chmod -rx SANETESTD.2 ||
1162        error "bug in test sript: cannot prepare SANETESTD"
1163
1164        ! test -r SANETESTD.1/x &&
1165        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1166        status=$?
1167
1168        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1169        rm -rf SANETESTD.1 SANETESTD.2 ||
1170        error "bug in test sript: cannot clean SANETESTD"
1171        return $status
1172'
1173
1174test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1175GIT_UNZIP=${GIT_UNZIP:-unzip}
1176test_lazy_prereq UNZIP '
1177        "$GIT_UNZIP" -v
1178        test $? -ne 127
1179'
1180
1181run_with_limited_cmdline () {
1182        (ulimit -s 128 && "$@")
1183}
1184
1185test_lazy_prereq CMDLINE_LIMIT '
1186        test_have_prereq !MINGW,!CYGWIN &&
1187        run_with_limited_cmdline true
1188'
1189
1190run_with_limited_stack () {
1191        (ulimit -s 128 && "$@")
1192}
1193
1194test_lazy_prereq ULIMIT_STACK_SIZE '
1195        test_have_prereq !MINGW,!CYGWIN &&
1196        run_with_limited_stack true
1197'
1198
1199build_option () {
1200        git version --build-options |
1201        sed -ne "s/^$1: //p"
1202}
1203
1204test_lazy_prereq LONG_IS_64BIT '
1205        test 8 -le "$(build_option sizeof-long)"
1206'
1207
1208test_lazy_prereq TIME_IS_64BIT 'test-date is64bit'
1209test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit'